<?php 
/**
* $Id: functions.php,v 1.0 2005/31/12 12:00:00 thomasz Exp $
*
* @author       Thomas Zeithaml <info@spider-trap.de>
* @copyright    (c) 2005-2006 Spider-Trap Team
* 
* The contents of this file are subject to the Mozilla Public License
* Version 1.1 (the "License"); you may not use this file except in
* compliance with the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
* 
* Software distributed under the License is distributed on an "AS IS"
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
* License for the specific language governing rights and limitations
* under the License.
*/

/**
* Function to show the captcha picture
*/
function display_captcha() {
  $letters = array('1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
  $code = '';
  for ($i = 1; $i <= 4; $i++) {
    $j = floor(rand(0,34));
    $code .= $letters [$j];
  }
    setCaptchaId($code);
    $fonts=array();
  $fonts=glob("./fonts/*.ttf");
  if(!$fonts){
    echo"Keine Fonts gefunden.";
  }
  $width = 150;
    $height = 50;

    // Erstellen eine 40 mal 100 px groen Bildes
    $img = imagecreate($width,$height);
    imagefilledrectangle($img, 0, 0, $width, $height, random_color($img, 222, 255));

    // Farben definieren
    $color1 = rand(150, 185);
    $color2 = rand(185, 225);

    // Strlinien definieren
  $wd = 4;
    $w1 = 0;
    $w2 = 0;
    for ($x=0; $x<$width; $x+=(int)$wd) {
      if ($x < $width) {   // verical
          imageline($img, $x+$w1, 0, $x+$w2, $height-1, random_color($img,$color1,$color2));
        }
        if ($x < $height) {  // horizontally ("y")
            imageline($img, 0, $x-$w2, $width-1, $x-$w1, random_color($img,$color1,$color2));
         }
         $wd += rand(0,8) - 4;
         if ($wd < 1) { $wd = 2; }
         $w1 += rand(0,8) - 4;
         $w2 += rand(0,8) - 4;
         if (($x > $height) && ($y > $height)) {
            break;
         }
      }

      $len = strlen($code);
      $w1 = 10;
      $w2 = $width / ($len+1);
      for ($p=0; $p<$len; $p++) {
         $letter = $code[$p];
         $size = rand(18, $height/2.2);
         $half = (int) $size / 2;
         $rotation = rand(-33, 33);
         $y = rand($size+3, $height-3);
         $x = $w1 + $w2*$p;
         $w1 += rand(-$width/90, $width/40);  // @BUG: last char could be +30 pixel outside of image
         $font = $fonts[rand(0, count($fonts)-1)];
         $r=mt_rand(30,199); $g=mt_rand(30,199); $b=mt_rand(30,199); // two colors for shadow
         $c1  = imagecolorallocate($img, $r*1, $g*1, $b*1);
         $c2  = imagecolorallocate($img, $r*2, $g*2, $b*2);

     if (function_exists('imagettftext')) { 
          imagettftext($img, $size, $rotation, $x+1, $y, $c2, $font, $letter);
         imagettftext($img, $size, $rotation, $x, $y-1, $c1, $font, $letter);
     } else {                                            
         $tc = ImageColorAllocate ($img, 0, 0, 0); 
           ImageString($img, $size, 26+(36*$p),20, substr($letter, $p, 1), $tc);  
         }
      }
      $quality = 30;


    header('Content-Type: image/jpeg');
    imagejpeg($img, "", (int)$quality);
    imagedestroy($img);
}


/**
* Function to get the ID from the captcha file
*/
function getCaptchaId () {
  return (file_get_contents ($spider_files['captcha_file']));
}


/**
* Function to write the id to the file
*/
function setCaptchaId ($data){
  file_put_contents ($spider_files['captcha_file'], $data);
  return (  $data);
}


/**
* Function to get different colors
*/
function random_color($img, $a,$b) {
    return imagecolorallocate($img, rand($a,$b), rand($a,$b), rand($a,$b));
}


/**
* Function to get a pretty formatted output of an array
*/
function spider_dump ($array) {
  return (print ('<pre>'.print_r($array, true).'</pre>'));
}


/**
* comming soon
* is IP an bad bot IP ?
* in the file we are also wildcards supported 
* f.e. 81.123.123 means 81.123.123.1 - 81.123.123.255
*/
function isBadIP($ip){

  $badbot = 0;
  $iparray = explode(".", $ip);

  $fp = fopen('badips.txt', "r")
  or die ("Error while open: badips.txt<br>\n");
  while ($line = fgets($fp,255)) {
    $teile = explode(".", $line);
    $bot1 = 0;
    $bot2 = 0;
    $bot3 = 0;
    $bot4 = 0;
    // Teil 1
    if (preg_match("/".$iparray[0] . "/i", $teile[0]) ) {
      $bot1 = 1;
    }
    // Teil 2
    if (preg_match("/".$iparray[1] . "/i", $teile[1]) ) {
      $bot2 = 1;
    }
    // Teil 3
    if (preg_match("/".$iparray[2] . "/i", $teile[2]) ) {
      $bot3 = 1;
    }
    // Teil 4
    $result = count ($teile);
    if ($result == 3) {
      $bot4 = 1;
    } else {
      if (preg_match("/".$iparray[3] . "/i", $teile[3]) ) {
        $bot4 = 1;
      }
    }
    if ($bot1 == 1 and $bot2 == 1 and $bot3 == 1 and $bot4 == 1) {
      $badbot++;
      break;
    }
  }
  fclose($fp);
  return $badbot;
}




/**
* is listet in htaccess
*/
function is_htaccesslisted ($ip){
  $badbot = 0;
  global $spider_files, $umbruch;
  
  // htaccess durchsuchen ob IP Addresse vorhanden
  $fp = fopen($spider_files['htaccess_file'], "r")
      or die ("Error open: ".$spider_files['htaccess_file']." <br>\n");
  if (flock($fp, LOCK_SH)) 
    {
      while ($line = fgets($fp,255))  
        {
      if (eregi("deny",$line)) { $umbruch = true; }
          if (ereg($ip,$line)) { $badbot++; }
        }
      flock($fp, LOCK_UN); 
    }
  else 
    {
      echo "<p>Can't get lock for ".$spider_files['htaccess_file']."</p>";
    }
  fclose($fp);
  return $badbot;
}


/**
* is listet in whitelist
*/
function is_whitelisted ($ip,$http_user_agent) {
  $goodbot = 0;
  global $spider_files;

  // whitelist durchsuchen ob User agent Addresse vorhanden
  $fp = fopen($spider_files['whitelist_file'], "r")
      or die ("Fehler beim oeffnen: ".$spider_files['whitelist_file']." <br>\n");
  if (flock($fp, LOCK_SH)) 
    {
      while ($line = fgets($fp,255))  
        {
    $http_user_agent = trim($http_user_agent);
    $line = trim($line);
      if ($line <> '') {
        if (eregi($line,$http_user_agent)) { 
			$goodbot++; 
		}
        if (ereg($ip,$line)) { 
			$goodbot++; 
        }
	  }
    }
      flock($fp, LOCK_UN); 
    }
  else 
    {
      echo "<p>Can't get lock for ".$spider_files['whitelist_file']."</p>";
    }
  fclose($fp);
  return $goodbot;
}


/**
* is listet in blacklist
*/
function is_blacklisted ($ip,$user_agent){
  
  $badbot = 0;
  global $spider_files;

  // blacklist durchsuchen ob IP Addresse vorhanden
  $fp = fopen($spider_files['blacklist_file'], "r")
      or die ("Fehler beim oeffnen: ".$spider_files['blacklist_file']." <br>\n");
  if (flock($fp, LOCK_SH)) 
    {
      while ($line = fgets($fp,255))  
        {
          if (ereg($ip,$line)) { $badbot++; }
        }
      flock($fp, LOCK_UN); 
    }
  else 
    {
      echo "<p>Can't get lock for ".$spider_files['blacklist_file']."</p>";
    }
  fclose($fp);

  // user_agent_file durchsuchen ob user_agent vorhanden
  $fp = fopen($spider_files['user_agent_file'], "r")
      or die ("Fehler beim oeffnen: ".$spider_files['user_agent_file']." <br>\n");
  if (flock($fp, LOCK_SH)) 
    {
      while ($line = fgets($fp,255))  
        {
          if (ereg($user_agent,$line)) { $badbot++; }
        }
      flock($fp, LOCK_UN); 
    }
  else 
    {
      echo "<p>Can't get lock for ".$spider_files['user_agent_file']."</p>";
    }
  fclose($fp);

  return $badbot;
}


/**
* add IP to blacklist
*/
function add_blacklist ($ip, $req_method, $req_uri, $server_protocol,
    $http_referrer, $http_user_agent) {
  global $spider_files, $spider_conf, $mail_on_add, $umbruch;
  
  $http_referrer = (isset ($http_referrer) && trim ($http_referrer)) ? $http_referrer : 'no referer';
  $http_user_agent = (isset ($http_user_agent) && trim ($http_user_agent)) ? $http_user_agent : 'no user agent';
  
  $ip = getip();
  $ip_added = 0;
  
  // auf whitelist ?
  if (is_whitelisted($ip,$http_user_agent)) { 
    header("Status: 301 Moved Permanently");
    header("Location: ../");
    exit;
  }

  // schon vorhanden ?
  if (!is_blacklisted($ip,$http_user_agent)) { 
    $ip_added = 1;
    // IP in blacklist aufnehmen
    $timestamp = time();
    $datum = date("d.m.Y|H.i.s",$timestamp);
    if (!is_file($spider_files['blacklist_file']))
      {
        echo "<p>Can't open ".$spider_files['blacklist_file'].", do you have permissions to it?</p>";
        return;
      }
    $fp = fopen($spider_files['blacklist_file'],'a+');
    if (flock($fp, LOCK_EX))
      {
    fwrite($fp,"$ip|$datum|$http_referrer|$http_user_agent|\n"); // the separator has to be the pipe(= |), otherwise errors will appear in the reg ex of the function "deleteExpired ()"
        flock($fp, LOCK_UN);
      }
    else
      {
        echo "<p>Couldn't get lock for ".$spider_files['blacklist_file']."</p>";
      }
    fclose($fp);
   }

  // schon vorhanden ?
  if (!is_htaccesslisted($ip)) { 
    $ip_added = 1;
    /* Sperre ber .htaccess file */
    if (!is_file($spider_files['htaccess_file']))
      {
        echo "<p>Can't open ".$spider_files['htaccess_file'].", do you have permissions to it?</p>";
        return;
      }
    $fp = fopen($spider_files['htaccess_file'],'a+');
    if (flock($fp, LOCK_EX))
      {
  if (!$umbruch) {
    fwrite($fp,"\n\nOrder Deny,Allow\n");
  }
    fwrite($fp,"Deny from $ip\n");
        flock($fp, LOCK_UN);
      }
    else
      {
        echo "<p>Couldn't get lock for ".$spider_files['htaccess_file']."</p>";
      }
    fclose($fp);
   }

  if ($spider_conf['email_on_ban'] != 0 && $ip_added == 1) {
      // Email an Webmaster
      $subject = 'spider-trap : Neuer Spambot gesperrt - '.$_SERVER['HTTP_HOST'];
      $msg = "Neuer Spambot: $req_uri $datum \n";
      $msg .= "Host: ".$_SERVER['HTTP_HOST']." \n";
      $msg .= "IP: $ip \n";
      $msg .= "User-Agent: $http_user_agent\n\n";
      $msg .= 'WHOIS: http://whois.domaintools.com/'.$ip;
      mail ($spider_conf['alert_email'], $subject, $msg, 'From: '.$spider_conf['alert_email']);
  }
  if ($spider_conf['report_ips'] != 0 && $ip_added == 1) {
    $msg = 'Host : '.$_SERVER['HTTP_HOST']."\n";
    $msg .= 'URI : '.$req_uri."\n";
    $msg .= 'IP : '.$ip."\n";
    $msg .= 'User-Agent : '.$http_user_agent."\n\n";
	$msg .= 'WHOIS: http://whois.domaintools.com/'.$ip;
    mail ('badbot@spider-trap.de', 'Neuer Spambot erkannt', $msg, 'From: report_spider@'.$_SERVER['HTTP_HOST']);
  }
  
}


/**
* ---
*/
function remove_line_from_file ($file, $regex)
{
  /* Read good lines into $new_fp */
  if (!is_file("$file"))
    {
      echo "<p>Can't open $file, do you have write permissions to it?</p>";
      return;
    }
  $fp = fopen("$file",'r');
  if (!flock($fp, LOCK_EX))
    {
      echo "<p>Couldn't get lock for $file</p>";
      fclose($fp);
      return;
    }
  $new_fp_name = 'files/' . md5(time() * rand(1, 9999999));
  $new_fp = fopen($new_fp_name, "w");
  if (!is_file($new_fp_name))
    {
      echo "<p>File $new_fp_name doesn't exist, can you create this file?</p>";
      return;
    }
  while ($line = fgets($fp,255))  
    {
      if (!ereg($regex,$line)) { fwrite($new_fp, $line); }
    }
  flock($fp, LOCK_UN);
  fclose($fp);
  fclose($new_fp);

  /* Read $new_fp into $fp (moving will change ownership) */
  $fp = fopen("$file",'w');
  if (!flock($fp, LOCK_EX))
    {
      echo "<p>Couldn't get lock for $file</p>";
      fclose($fp);
      return;
    }
  $new_fp = fopen($new_fp_name, "r");

  while ($line = fgets($new_fp,255))  
    {
      fwrite($fp, $line);
    }
  flock($fp, LOCK_UN);
  fclose($fp);
  fclose($new_fp);
  unlink($new_fp_name);
}


/**
* remove ip from blacklist
*/
function remove_blacklist ($ip, $http_user_agent) {
  global $spider_files, $spider_conf;
  if (is_blacklisted($ip, $http_user_agent))
  {
    remove_line_from_file($spider_files['blacklist_file'], $ip);
    remove_line_from_file($spider_files['htaccess_file'], $ip);

  if ($spider_conf['email_on_unban'] != 0) {
      // E-Mail an Webmaster
      $subject = 'Spider-Trap : Spambot aus Liste entfernt - '.$_SERVER['HTTP_HOST'];
      $msg = "Neuer Spambot: $req_uri $datum \n";
      $msg .= "Host: ".$_SERVER['HTTP_HOST']." \n";
      $msg .= "IP: $ip \n";
      $msg .= "User-Agent: $http_user_agent\n\n";
      $msg .= 'WHOIS: http://whois.domaintools.com/'.$ip;
      mail ($spider_conf['alert_email'], $subject, $msg, 'From: '.$spider_conf['alert_email']);
    }
  }
}


/**
* some ips can not be valid
*/
function validip($ip) {
   if (!empty($ip) && ip2long($ip)!=-1) {
       $reserved_ips = array (
       array('0.0.0.0','2.255.255.255'),
       array('10.0.0.0','10.255.255.255'),
       array('127.0.0.0','127.255.255.255'),
       array('169.254.0.0','169.254.255.255'),
       array('172.16.0.0','172.31.255.255'),
       array('192.0.2.0','192.0.2.255'),
       array('192.168.0.0','192.168.255.255'),
       array('255.255.255.0','255.255.255.255')
       );

       foreach ($reserved_ips as $r) {
           $min = ip2long($r[0]);
           $max = ip2long($r[1]);
           if ((ip2long($ip) >= $min) && (ip2long($ip) <= $max)) return false;
       }
       return true;
   } else {
       return false;
   }
}


/**
* Function to get the right IP because REMOTE_ADDR can be empty
*/
function getip() {
   if (validip($_SERVER["HTTP_CLIENT_IP"])) {
       return $_SERVER["HTTP_CLIENT_IP"];
   }
   foreach (explode(",",$_SERVER["HTTP_X_FORWARDED_FOR"]) as $ip) {
       if (validip(trim($ip))) {
           return $ip;
       }
   }
   if (validip($_SERVER["HTTP_X_FORWARDED"])) {
       return $_SERVER["HTTP_X_FORWARDED"];
   } elseif (validip($_SERVER["HTTP_FORWARDED_FOR"])) {
       return $_SERVER["HTTP_FORWARDED_FOR"];
   } elseif (validip($_SERVER["HTTP_FORWARDED"])) {
       return $_SERVER["HTTP_FORWARDED"];
   } elseif (validip($_SERVER["HTTP_X_FORWARDED"])) {
       return $_SERVER["HTTP_X_FORWARDED"];
   } else {
       return $_SERVER["REMOTE_ADDR"];
   }
}



########################################################################
// new or changed functions
########################################################################


/**
* simulate the php5 function "file_get_contents ()", if it doesn`t exist
*/
if (!function_exists ('file_get_contents')) {
  function file_get_contents ($path) {
    $content = '';
    if (file_exists ($path)) {
    $handle = fopen ($path, 'r');
      while (!feof ($handle)) {
        $content .= fgets ($handle, 4096);
      }
      fclose ($handle);
      return ($content);
    } else {
      trigger_error ('The file "'.htmlentities ($path).'does not exists');
      return (false);
    }
  }
}


/**
* simulate the php5 function "file_put_contents ()", if it doesn`t exist
*/
if (!function_exists ('file_put_contents')) {
  function file_put_contents ($path, $data) {
    if (!is_writable ($path)) {
      return ('<p>Cannot open '.htmlentities ($path).'.<p>');
    }
    $handle = fopen ($path, 'w');
    if (!$handle) {
      return ('<p>Cannot open '.htmlentities ($path).'.<p>');
    }
    if (!flock ($handle, LOCK_SH)) {
      return ('<p>Cannot lock '.htmlentities ($path).'.<p>');
    }
    if (is_array ($data)) {
      foreach ($data as $line) {
        fwrite ($handle, $line);
      }
    } else {
      fwrite ($handle, $data);
    }
    flock ($handle, LOCK_UN); 
    fclose ($handle);
    return (strlen ($data));
  }
}


/**
* the function should describes itself
*/
function replaceWildcard ($wildcard, $value, $tpl) {
  return (preg_replace ('/\{'.preg_quote ($wildcard, '/').'\}/Us', $value, $tpl));
}


/**
* the function should describes itself
*/
function deleteExpired ($sec = '14400') { // 14400 seconds = 4 hours
  global $spider_files;
  $time = time () - $sec;
  
  // blacklist
  $new_blacklist = array ();
  $blacklist = file ($spider_files['blacklist_file']);
  foreach ($blacklist as $line) {
    $date = preg_replace ('/(.*)\|(.*)\|(.*)\|(.*)\|(.*)\|/Us', '\1.\3.\4', $line); // =>192.168.1.1.tt.mm.jjjj.hh.mm.ss
    $date = explode ('.', $date); // $date[0] = 192; $date[1] = 168 ... $date[4] = tt ... $date[9] = ss;
    $ip = $date[0].'.'.$date[1].'.'.$date[2].'.'.$date[3];
    $timestamp = mktime ($date[7], $date[8], $date[9], $date[5], $date[4], $date[6]);
    if ($time > $timestamp) {
      remove_line_from_file ($spider_files['htaccess_file'], $ip);
    } else {
      $new_blacklist = $line;
    }
  }
  file_put_contents ($spider_files['blacklist_file'], $new_blacklist);
}
?>